package main

import (
    "fmt"
    "log"
    "net/http"

    "github.com/gorilla/mux"
)

func main() {
    r := mux.NewRouter()
    r.HandleFunc("/health", healthHandler)
    http.Handle("/", r)

    addr := ":8080"
    log.Printf("server starting on %s", addr)
    if err := http.ListenAndServe(addr, nil); err != nil {
        log.Fatalf("error: %s", err)
    }
}

func healthHandler(w http.ResponseWriter, r *http.Request) {
    // TODO: Run health checks
    fmt.Fprintln(w, "OK")
}
